API 參考

認證與權杖

所有 GraphQL 請求都需要在 Authorization 標頭中攜帶 Bearer token,並在 c-id (用戶端 ID) 標頭中攜帶用戶端 ID。兩者均可從 PlainApp Settings → Sessions & API Tokens 取得。ADB token 是獨立的,僅用於 Android 自動化以啟動或停止 HTTP 伺服器——可在 Settings → Developer Options 中找到。

型別定義

bash
# GraphQL requests must include both headers:
c-id: <client-id>
Authorization: Bearer <api-token>

# Endpoint : POST /graphql

操作

http

API Token

在 PlainApp Settings → Sessions & API Tokens → API Tokens 分頁中建立 API token。每個 token 包含一個用戶端 ID 和一個 token 值。將兩者作為請求標頭傳送:c-id 用於用戶端 ID,Authorization: Bearer 用於 token。

bash
# On your Android device:
# 1. Open PlainApp
# 2. Go to Settings → Sessions & API Tokens
# 3. Open the "API Tokens" tab
# 4. Tap + to create a new token
# 5. Copy the c-id and token values shown

curl --request POST \
  --url http://192.168.1.100:8080/graphql \
  --header 'c-id: <your-client-id>' \
  --header 'Authorization: Bearer <your-api-token>' \
  --header 'Content-Type: application/json' \
  --data '{"query":"{ chatItems { content } }"}'
app

ADB Token

ADB token 專門用於 Android 自動化——透過 adb broadcast 啟動和停止 PlainApp HTTP 伺服器。可在 PlainApp Settings → Developer Options 中找到。它不是用於 GraphQL 請求的 Bearer token。

bash
# Start the HTTP server
adb shell am broadcast -a com.ismartcoding.plain.action.START_HTTP_SERVER -p com.ismartcoding.plain --es token <your-adb-token>

# Stop the HTTP server
adb shell am broadcast -a com.ismartcoding.plain.action.STOP_HTTP_SERVER -p com.ismartcoding.plain --es token <your-adb-token>
app

plainapp-cli (AI Agent)

plainapp-cli 是一款 Rust 命令列工具,專為 AI 可呼叫的 CLI 設計。將它交給任何能夠執行 shell 命令的 AI agent,即可讓該 agent 透過 PlainApp GraphQL API 檢查和控制手機資料——聯絡人、SMS、檔案、筆記、通話等。

bash
# Install (macOS & Linux one-liner)
bash <(curl -fsSL https://raw.githubusercontent.com/plainhub/plainapp-cli/main/install.sh)

# Or build from source (requires Rust ≥ 1.75)
cargo install --path .

# --- Setup ---
# 1. Open PlainApp → Settings → Sessions & API Tokens → API Tokens tab
# 2. Tap + to create a token, note the Client ID and Token
# 3. Run to generate config:
plainapp-cli --init
# Edit ~/.config/plainapp-cli/config.toml:
# api_url   = "https://192.168.1.100:8443"
# client_id = "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
# token     = "BASE64_ENCODED_32_BYTE_TOKEN"

# --- Usage ---
# Fetch the full GraphQL schema (for AI introspection)
plainapp-cli --schema

# Execute any GraphQL query or mutation
plainapp-cli --exec '<json>'

# Examples:
# List SMS conversations
plainapp-cli -e '{"query":"{ smses(limit:20,offset:0) { id address body date } }","variables":null}'

# List notes
plainapp-cli -e '{"query":"{ app { battery sdcardPath } }","variables":null}'

# Delete a file
plainapp-cli -e '{
  "query": "mutation DeleteFiles($paths:[String!]!) { deleteFiles(paths:$paths) }",
  "variables": {"paths":["/sdcard/tmp/test.txt"]}
}'